"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var React = require("react"), theme = require("@uidu/theme"), styled = require("styled-components");

function _interopDefault(e) {
  return e && e.__esModule ? e : {
    default: e
  };
}

var React__default = _interopDefault(React), styled__default = _interopDefault(styled);

function _typeof(obj) {
  return (_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(obj) {
    return typeof obj;
  } : function(obj) {
    return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  })(obj);
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter((function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    }))), keys.push.apply(keys, symbols);
  }
  return keys;
}

function _objectSpread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys(Object(source), !0).forEach((function(key) {
      _defineProperty(target, key, source[key]);
    })) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach((function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    }));
  }
  return target;
}

function _defineProperty(obj, key, value) {
  return key in obj ? Object.defineProperty(obj, key, {
    value: value,
    enumerable: !0,
    configurable: !0,
    writable: !0
  }) : obj[key] = value, obj;
}

var defaultBackgroundColor = {
  default: {
    light: theme.colors.N40,
    dark: theme.colors.N40
  },
  inprogress: {
    light: theme.colors.B50,
    dark: theme.colors.B50
  },
  moved: {
    light: theme.colors.Y75,
    dark: theme.colors.Y75
  },
  new: {
    light: theme.colors.P50,
    dark: theme.colors.P50
  },
  removed: {
    light: theme.colors.R50,
    dark: theme.colors.R50
  },
  success: {
    light: theme.colors.G50,
    dark: theme.colors.G50
  }
}, defaultTextColor = {
  default: {
    light: theme.colors.N500,
    dark: theme.colors.N500
  },
  inprogress: {
    light: theme.colors.B500,
    dark: theme.colors.B500
  },
  moved: {
    light: theme.colors.N800,
    dark: theme.colors.N800
  },
  new: {
    light: theme.colors.P500,
    dark: theme.colors.P500
  },
  removed: {
    light: theme.colors.R500,
    dark: theme.colors.R500
  },
  success: {
    light: theme.colors.G500,
    dark: theme.colors.G500
  }
}, boldBackgroundColor = {
  default: {
    light: theme.colors.N500,
    dark: theme.colors.N500
  },
  inprogress: {
    light: theme.colors.B400,
    dark: theme.colors.B400
  },
  moved: {
    light: theme.colors.Y500,
    dark: theme.colors.Y500
  },
  new: {
    light: theme.colors.P400,
    dark: theme.colors.P400
  },
  removed: {
    light: theme.colors.R400,
    dark: theme.colors.R400
  },
  success: {
    light: theme.colors.G400,
    dark: theme.colors.G400
  }
}, boldTextColor = {
  default: {
    light: theme.colors.N0,
    dark: theme.colors.N0
  },
  inprogress: {
    light: theme.colors.N0,
    dark: theme.colors.N0
  },
  moved: {
    light: theme.colors.N800,
    dark: theme.colors.N800
  },
  new: {
    light: theme.colors.N0,
    dark: theme.colors.N0
  },
  removed: {
    light: theme.colors.N0,
    dark: theme.colors.N0
  },
  success: {
    light: theme.colors.N0,
    dark: theme.colors.N0
  }
}, Theme = theme.createTheme((function(_ref) {
  var appearance = _ref.appearance, isBold = _ref.isBold, maxWidth = _ref.maxWidth;
  return _objectSpread(_objectSpread({}, "object" === _typeof(appearance) ? _objectSpread({
    backgroundColor: (isBold ? boldBackgroundColor : defaultBackgroundColor).default.light,
    textColor: (isBold ? boldTextColor : defaultTextColor).default.light
  }, appearance) : {
    backgroundColor: (isBold ? boldBackgroundColor[appearance] : defaultBackgroundColor[appearance]).light,
    textColor: (isBold ? boldTextColor[appearance] : defaultTextColor[appearance]).light
  }), {}, {
    maxWidth: maxWidth
  });
})), BORDER_RADIUS = "40px", Container = styled__default.default.span.withConfig({
  displayName: "Container",
  componentId: "sc-5z8x30-0"
})([ "background-color:", ";color:", ";max-width:100%;vertical-align:baseline;line-height:20px;display:inline-block;padding:1px 8px;font-size:12px;font-weight:500;letter-spacing:0.05em;border-radius:", ";text-transform:uppercase;" ], (function(props) {
  return props.backgroundColor;
}), (function(props) {
  return props.textColor;
}), BORDER_RADIUS), HORIZONTAL_SPACING = "".concat(theme.gridSize() / 2, "px"), Content = styled__default.default.span.withConfig({
  displayName: "Content",
  componentId: "kuvtw4-0"
})([ "display:inline-block;vertical-align:top;overflow:hidden;text-overflow:ellipsis;white-space:nowrap;box-sizing:border-box;padding:0 ", ";max-width:", ";width:100%;" ], HORIZONTAL_SPACING, (function(props) {
  return "number" == typeof props.maxWidth ? "".concat(props.maxWidth, "px") : props.maxWidth;
}));

function _typeof$1(obj) {
  return (_typeof$1 = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(obj) {
    return typeof obj;
  } : function(obj) {
    return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  })(obj);
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) throw new TypeError("Cannot call a class as a function");
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || !1, descriptor.configurable = !0, 
    "value" in descriptor && (descriptor.writable = !0), Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  return protoProps && _defineProperties(Constructor.prototype, protoProps), staticProps && _defineProperties(Constructor, staticProps), 
  Constructor;
}

function _inherits(subClass, superClass) {
  if ("function" != typeof superClass && null !== superClass) throw new TypeError("Super expression must either be null or a function");
  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: !0,
      configurable: !0
    }
  }), superClass && _setPrototypeOf(subClass, superClass);
}

function _setPrototypeOf(o, p) {
  return (_setPrototypeOf = Object.setPrototypeOf || function(o, p) {
    return o.__proto__ = p, o;
  })(o, p);
}

function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function() {
    var result, Super = _getPrototypeOf(Derived);
    if (hasNativeReflectConstruct) {
      var NewTarget = _getPrototypeOf(this).constructor;
      result = Reflect.construct(Super, arguments, NewTarget);
    } else result = Super.apply(this, arguments);
    return _possibleConstructorReturn(this, result);
  };
}

function _possibleConstructorReturn(self, call) {
  return !call || "object" !== _typeof$1(call) && "function" != typeof call ? _assertThisInitialized(self) : call;
}

function _assertThisInitialized(self) {
  if (void 0 === self) throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return self;
}

function _isNativeReflectConstruct() {
  if ("undefined" == typeof Reflect || !Reflect.construct) return !1;
  if (Reflect.construct.sham) return !1;
  if ("function" == typeof Proxy) return !0;
  try {
    return Date.prototype.toString.call(Reflect.construct(Date, [], (function() {}))), 
    !0;
  } catch (e) {
    return !1;
  }
}

function _getPrototypeOf(o) {
  return (_getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  })(o);
}

function _defineProperty$1(obj, key, value) {
  return key in obj ? Object.defineProperty(obj, key, {
    value: value,
    enumerable: !0,
    configurable: !0,
    writable: !0
  }) : obj[key] = value, obj;
}

var Lozenge = function(_PureComponent) {
  _inherits(Lozenge, React.PureComponent);
  var _super = _createSuper(Lozenge);
  function Lozenge() {
    return _classCallCheck(this, Lozenge), _super.apply(this, arguments);
  }
  return _createClass(Lozenge, [ {
    key: "render",
    value: function() {
      var _this$props = this.props, theme = _this$props.theme, children = _this$props.children;
      return React__default.default.createElement(Theme.Provider, {
        value: theme
      }, React__default.default.createElement(Theme.Consumer, this.props, (function(tokens) {
        return React__default.default.createElement(Container, tokens, React__default.default.createElement(Content, tokens, children));
      })));
    }
  } ]), Lozenge;
}();

_defineProperty$1(Lozenge, "defaultProps", {
  isBold: !1,
  appearance: "default",
  maxWidth: 200
}), exports.default = Lozenge;
